ListKong/Controllers/LocationController.cs
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Threading.Tasks;
using ListKong.Models;
using ListKong.Utility;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Configuration;

namespace ListKong.Controllers
{
    public class LocationController : Controller
    {
        #region Controller Properties
        private IConfiguration _configuration;
        private CommonHelper _objHelper;
        private SQLGateway _objDataHelper;
        public string cnnect;
        public string keyForEncrypt, encryptedToken, encryptedEmail, formFlag;
        #endregion
        public LocationController(IConfiguration configuration)
        {
            this._configuration = configuration;
            this._objDataHelper = new SQLGateway(this._configuration.GetConnectionString("DefaultConnection"));
            this._objHelper = new CommonHelper(this._configuration);
            cnnect = this._configuration.GetConnectionString("DefaultConnection");
        }
        public IActionResult Index()
        {
            string companyName = HttpContext.Session.GetString("_CompanyName");
            if (string.IsNullOrEmpty(companyName))
            {
                return RedirectToAction("Index", "Company");
            }
            try
            {
                DataTable _dtResponseP = LocationList();
                if (this._objHelper.checkDBNullResponse(_dtResponseP))
                {
                    List<LocationListModel> lst = new List<LocationListModel>();
                    lst = ExtensionMethods.DataTableToList<LocationListModel>(_dtResponseP);
                    return View(lst);
                }
            }
            catch (Exception ex)
            {
                string E = ex.Message.ToString();
                return View();
            }
            return View();
        }
        public async Task<IActionResult> AddLocation()
        {
            LocationModel model = new LocationModel();
            model.CompanyId = Convert.ToInt64(HttpContext.Session.GetString("_CompanyId"));
            model.CompanyName = HttpContext.Session.GetString("_CompanyName");
            return View(model);
        }
        [HttpPost]
        public async Task<IActionResult> AddLocation(LocationModel model)
        {

            if (!ModelState.IsValid)
            {
                return View(model);
            }
            try
            {
                var userId = @User.Claims.FirstOrDefault(c => c.Type == "http://schemas.xmlsoap.org/ws/2005/05/identity/claims/nameidentifier").Value;
                List<KeyValuePair<string, string>> parameters = new List<KeyValuePair<string, string>>();
                parameters.Add(new KeyValuePair<string, string>("@userId", userId));
                parameters.Add(new KeyValuePair<string, string>("@CompanyId", Convert.ToString(model.CompanyId)));
                parameters.Add(new KeyValuePair<string, string>("@City", model.City));
                parameters.Add(new KeyValuePair<string, string>("@Country", model.Country));
                parameters.Add(new KeyValuePair<string, string>("@LocationAddress1", model.LocationAddress1));
                parameters.Add(new KeyValuePair<string, string>("@LocationAddress2", model.LocationAddress2));
                parameters.Add(new KeyValuePair<string, string>("@LocationDescription", model.LocationDescription));
                parameters.Add(new KeyValuePair<string, string>("@LocationName", model.LocationName));
                parameters.Add(new KeyValuePair<string, string>("@State", model.State));
                parameters.Add(new KeyValuePair<string, string>("@ZipCode", model.ZipCode));
                DataTable dt = _objDataHelper.ExecuteProcedure("app_Add_New_Location_By_Company", parameters);
                if (dt != null && dt.Rows.Count > 0)
                {
                    if (Convert.ToString(dt.Rows[0]["Result"]) == "0")
                    {
                        ViewData["ErrorMessage"] = "Location already exists!";
                        return View(model);
                    }
                    else
                    {

                        TempData["SuccessMessage"] = "Location successfully added!";
                        return RedirectToAction("Index");
                    }
                }
                else
                {
                    ViewData["ErrorMessage"] = "There is some error. Please try later!";
                    return View(model);
                }

                //RedirectToAction("AddInventory");

            }
            catch (Exception ex)
            {
                ViewData["ErrorMessage"] = "There is some error. Please try later!";
                string msg = ex.Message.ToString();
            }
            return View(model);
        }
        public string SetDefaultLocation(string Id)
        {
            SetDefaultLoc(Id);
            return "Ok";
        }

        public async Task<IActionResult> Edit(string Id)
        {
            LocationModel model = new LocationModel();
            try
            {
                DataTable _dtResponseP = LocationDetailById(Id);
                if (this._objHelper.checkDBNullResponse(_dtResponseP))
                {
                    List<LocationModel> lst = new List<LocationModel>();
                    lst = ExtensionMethods.DataTableToList<LocationModel>(_dtResponseP);
                    return View(lst.FirstOrDefault());
                }
                return View(model);
            }
            catch (Exception ex)
            {
                string E = ex.Message.ToString();
                return View(model);
            }
        }
        [HttpPost]
        public async Task<IActionResult> Edit(LocationModel model)
        {
            if (!ModelState.IsValid)
            {
                return View(model);
            }
            try
            {
                var userId = @User.Claims.FirstOrDefault(c => c.Type == "http://schemas.xmlsoap.org/ws/2005/05/identity/claims/nameidentifier").Value;
                List<KeyValuePair<string, string>> parameters = new List<KeyValuePair<string, string>>();
                parameters.Add(new KeyValuePair<string, string>("@userId", userId));
                parameters.Add(new KeyValuePair<string, string>("@locationId", Convert.ToString(model.LocationId)));
                parameters.Add(new KeyValuePair<string, string>("@CompanyId", Convert.ToString(model.CompanyId)));
                parameters.Add(new KeyValuePair<string, string>("@City", model.City));
                parameters.Add(new KeyValuePair<string, string>("@Country", model.Country));
                parameters.Add(new KeyValuePair<string, string>("@LocationAddress1", model.LocationAddress1));
                parameters.Add(new KeyValuePair<string, string>("@LocationAddress2", model.LocationAddress2));
                parameters.Add(new KeyValuePair<string, string>("@LocationDescription", model.LocationDescription));
                parameters.Add(new KeyValuePair<string, string>("@LocationName", model.LocationName));
                parameters.Add(new KeyValuePair<string, string>("@State", model.State));
                parameters.Add(new KeyValuePair<string, string>("@ZipCode", model.ZipCode));
                DataTable dt = _objDataHelper.ExecuteProcedure("app_Update_Location_By_Id", parameters);
                if (dt != null && dt.Rows.Count > 0)
                {
                    if (Convert.ToString(dt.Rows[0]["Result"]) == "0")
                    {
                        ViewData["ErrorMessage"] = "Location already exists!";
                        return View(model);
                    }
                    else
                    {

                        TempData["SuccessMessage"] = "Location successfully Updated!";
                        return RedirectToAction("Index");
                    }
                }
                else
                {
                    ViewData["ErrorMessage"] = "There is some error. Please try later!";
                    return View(model);
                }

                //RedirectToAction("AddInventory");

            }
            catch (Exception ex)
            {
                ViewData["ErrorMessage"] = "There is some error. Please try later!";
                string msg = ex.Message.ToString();
            }
            return View(model);
        }
        public async Task<IActionResult> Delete(string Id)
        {
            LocationModel model = new LocationModel();
            try
            {
                DataTable _dtResponseP = DeleteLocation(Id);
                if (this._objHelper.checkDBNullResponse(_dtResponseP))
                {
                    if (Convert.ToString(_dtResponseP.Rows[0]["Result"]) == "1")
                    {
                        TempData["SuccessMessage"] = "Location successfully Deleted!";
                        return RedirectToAction("Index");
                    }
                    else
                    {
                        TempData["ErrorMessage"] = "There is some error. Please try later!";
                        return RedirectToAction("Index");
                    }
                }
                return View(model);
            }
            catch (Exception ex)
            {
                TempData["ErrorMessage"] = ex.Message.ToString();
                return RedirectToAction("Index");
            }
        }
        public DataTable LocationList()
        {
            var userId = @User.Claims.FirstOrDefault(c => c.Type == "http://schemas.xmlsoap.org/ws/2005/05/identity/claims/nameidentifier").Value;
            List<KeyValuePair<string, string>> parameters = new List<KeyValuePair<string, string>>();
            parameters.Add(new KeyValuePair<string, string>("@userId", userId));

ListKong/Views/Location/AddLocation.cshtml
@model ListKong.Models.LocationModel

@{
    ViewData["Title"] = "AddLocation";
}

<div class="container-fluid" style="min-height: 500.8px;margin:0 !important;">
    <section class="">

        <ol class="breadcrumb">
            <li><a asp-controller="Company" asp-action="Index"><i class="fa fa-dashboard"></i><span class="icon-after-span">Manage Company Location</span></a></li>
            <li class="active">Add Location</li>
        </ol>
    </section>
    <section class="content">
        <div class="row">

            <div class="panel panel-default">
                <div class="panel-heading">
                    <h4 class="box-title">Add Company</h4>
                </div>

                <form asp-action="AddLocation" enctype="multipart/form-data" method="post">
                    <div class="panel-body table-responsive">
                        <div class="col-md-12">
                            <div asp-validation-summary="ModelOnly" class="text-danger"></div>
                            @if (!string.IsNullOrEmpty(Convert.ToString(ViewData["ErrorMessage"])))
                            {
                                <div class="alert alert-danger">  @ViewData["ErrorMessage"]</div>
                                <script>
                                    $(function () {
                                        setTimeout(function () { hideTarget(); }, 5000);
                                    });
                                    function hideTarget() {
                                        $(".alert").hide();
                                    }
                                </script>
                            }
                            @if (!string.IsNullOrEmpty(Convert.ToString(ViewData["SuccessMessage"])))
                            {
                                <div class="alert alert-success">  @ViewData["SuccessMessage"]</div>
                                <script>
                                    $(function () {
                                        setTimeout(function () { hideTarget(); }, 5000);
                                    });
                                    function hideTarget() {
                                        $(".alert").hide();
                                    }
                                </script>
                            }
                            <input type="hidden" asp-for="CompanyId" class="form-control" />
                            <div class="col-md-6">
                                <label class="control-label">Company Name</label>
                                <input asp-for="CompanyName" class="form-control" style="pointer-events:none;" />

                            </div>
                            <div class="col-md-6">
                                <label asp-for="LocationName" class="control-label"></label>
                                <input asp-for="LocationName" class="form-control" />
                                <span asp-validation-for="LocationName" class="text-danger"></span>
                            </div>

                            <div class="col-md-6">
                                <label asp-for="Country" class="control-label"></label>
                                <input asp-for="Country" class="form-control" />
                                <span asp-validation-for="Country" class="text-danger"></span>
                            </div>
                            <div class="col-md-6">
                                <label asp-for="State" class="control-label"></label>
                                <input asp-for="State" class="form-control" />
                                <span asp-validation-for="State" class="text-danger"></span>
                            </div>
                            <div class="col-md-6">
                                <label asp-for="City" class="control-label"></label>
                                <input asp-for="City" class="form-control" />
                                <span asp-validation-for="City" class="text-danger"></span>
                            </div>
                            <div class="col-md-6">
                                <label asp-for="ZipCode" class="control-label"></label>
                                <input asp-for="ZipCode" class="form-control" />
                                <span asp-validation-for="ZipCode" class="text-danger"></span>
                            </div>
                            <div class="col-md-6">
                                <label asp-for="LocationAddress1" class="control-label"></label>
                                <input asp-for="LocationAddress1" class="form-control" />
                                <span asp-validation-for="LocationAddress1" class="text-danger"></span>
                            </div>
                            <div class="col-md-6">
                                <label asp-for="LocationAddress2" class="control-label"></label>
                                <input asp-for="LocationAddress2" class="form-control" />
                                <span asp-validation-for="LocationAddress2" class="text-danger"></span>
                            </div>
                            <div class="col-md-12">
                                <label asp-for="LocationDescription" class="control-label"></label>
                                <textarea asp-for="LocationDescription" class="form-control"></textarea>
                                <span asp-validation-for="LocationDescription" class="text-danger"></span>
                            </div>
                            <div class="form-group col-md-12">
                                <input type="submit" value="Create" class="btn btn-default" />
                            </div>
                        </div>
                    </div>
                </form>
                <div class="footer-listing">
                    <a asp-action="Index">Back to List</a>
                </div>

            </div>
        </div>
    </section>
</div>

ListKong/Views/Location/Edit.cshtml
@model ListKong.Models.LocationModel

@{
    ViewData["Title"] = "AddLocation";
}

<div class="container-fluid" style="min-height: 500.8px;margin:0 !important;">
    <section class="">

        <ol class="breadcrumb">
            <li><a asp-controller="Company" asp-action="Index"><i class="fa fa-dashboard"></i><span class="icon-after-span">Manage Location</span></a></li>
            <li class="active">Edit Location</li>
        </ol>
    </section>
    <section class="content">
        <div class="row">

            <div class="panel panel-default">
                <div class="panel-heading">
                    <h4 class="box-title">Edit Location</h4>
                </div>

                <form asp-action="Edit" enctype="multipart/form-data" method="post">
                    <div class="panel-body table-responsive">
                        <div class="col-md-12">
                            <div asp-validation-summary="ModelOnly" class="text-danger"></div>
                            @if (!string.IsNullOrEmpty(Convert.ToString(ViewData["ErrorMessage"])))
                            {
                                <div class="alert alert-danger">  @ViewData["ErrorMessage"]</div>
                                <script>
                                    $(function () {
                                        setTimeout(function () { hideTarget(); }, 5000);
                                    });
                                    function hideTarget() {
                                        $(".alert").hide();
                                    }
                                </script>
                            }
                            @if (!string.IsNullOrEmpty(Convert.ToString(ViewData["SuccessMessage"])))
                            {
                                <div class="alert alert-success">  @ViewData["SuccessMessage"]</div>
                                <script>
                                    $(function () {
                                        setTimeout(function () { hideTarget(); }, 5000);
                                    });
                                    function hideTarget() {
                                        $(".alert").hide();
                                    }
                                </script>
                            }
                            <input type="hidden" asp-for="CompanyId" class="form-control" />
                            <input type="hidden" asp-for="LocationId" class="form-control" />
                            <div class="col-md-6">
                                <label class="control-label">Company Name</label>
                                <input asp-for="CompanyName" class="form-control" style="pointer-events:none;" />

                            </div>
                            <div class="col-md-6">
                                <label asp-for="LocationName" class="control-label"></label>
                                <input asp-for="LocationName" class="form-control" />
                                <span asp-validation-for="LocationName" class="text-danger"></span>
                            </div>

                            <div class="col-md-6">
                                <label asp-for="Country" class="control-label"></label>
                                <input asp-for="Country" class="form-control" />
                                <span asp-validation-for="Country" class="text-danger"></span>
                            </div>
                            <div class="col-md-6">
                                <label asp-for="State" class="control-label"></label>
                                <input asp-for="State" class="form-control" />
                                <span asp-validation-for="State" class="text-danger"></span>
                            </div>
                            <div class="col-md-6">
                                <label asp-for="City" class="control-label"></label>
                                <input asp-for="City" class="form-control" />
                                <span asp-validation-for="City" class="text-danger"></span>
                            </div>
                            <div class="col-md-6">
                                <label asp-for="ZipCode" class="control-label"></label>
                                <input asp-for="ZipCode" class="form-control" />
                                <span asp-validation-for="ZipCode" class="text-danger"></span>
                            </div>
                            <div class="col-md-6">
                                <label asp-for="LocationAddress1" class="control-label"></label>
                                <input asp-for="LocationAddress1" class="form-control" />
                                <span asp-validation-for="LocationAddress1" class="text-danger"></span>
                            </div>
                            <div class="col-md-6">
                                <label asp-for="LocationAddress2" class="control-label"></label>
                                <input asp-for="LocationAddress2" class="form-control" />
                                <span asp-validation-for="LocationAddress2" class="text-danger"></span>
                            </div>
                            <div class="col-md-12">
                                <label asp-for="LocationDescription" class="control-label"></label>
                                <textarea asp-for="LocationDescription" class="form-control"></textarea>
                                <span asp-validation-for="LocationDescription" class="text-danger"></span>
                            </div>
                            <div class="form-group col-md-12">
                                <input type="submit" value="Update" class="btn btn-primary" />
                            </div>
                        </div>
                    </div>
                </form>
                <div class="footer-listing">
                    <a asp-action="Index">Back to List</a>
                </div>

            </div>
        </div>
    </section>
</div>

ListKong/Views/Location/Index.cshtml
@model IEnumerable<ListKong.Models.LocationListModel>

@{
    ViewData["Title"] = "Manage Location";
}

<div class="container-fluid" style="min-height: 500.8px;margin:0 !important;">

    <section class="content-header">

        <ol class="breadcrumb">
            <li><a href="#"><i class="fa fa-dashboard"></i><span class="icon-after-span"> Home</span></a></li>
            <li class="active">Manage Location</li>
        </ol>
    </section>
    <section class="content">
        <div class="row">
            <div class="col-md-12">
                <div class="panel panel-default">
                    <div class="panel-heading">
                        <h4 class="box-title">Location Listing</h4>
                        <div class="box-tools">
                            <div class="input-group input-group-sm" style="width: 150px;text-align:right;">
                                <a asp-controller="Location" asp-action="AddLocation"><i class="fa fa-plus-circle"></i><span class="icon-after-span">Add New</span></a>
                            </div>
                        </div>
                    </div>
                    <!-- /.box-header -->
                    <div class="panel-body table-responsive">
                        @if (!string.IsNullOrEmpty(Convert.ToString(TempData["ErrorMessage"])))
                        {
                            <div class="alert alert-danger">  @TempData["ErrorMessage"]</div>
                            <script>
                                $(function () {
                                    setTimeout(function () { hideTarget(); }, 5000);
                                });
                                function hideTarget() {
                                    $(".alert").hide();
                                }
                            </script>
                        }
                        @if (!string.IsNullOrEmpty(Convert.ToString(TempData["SuccessMessage"])))
                        {
                            <div class="alert alert-success">  @TempData["SuccessMessage"]</div>
                            <script>
                                $(function () {
                                    setTimeout(function () { hideTarget(); }, 5000);
                                });
                                function hideTarget() {
                                    $(".alert").hide();
                                }
                            </script>
                        }
                        <table class="table table-bordered">
                            <thead>
                                <tr>
                                    <th>
                                        @Html.DisplayNameFor(model => model.CompanyName)
                                    </th>
                                    <th>
                                        @Html.DisplayNameFor(model => model.LocationName)
                                    </th>
                                    <th>
                                        @Html.DisplayNameFor(model => model.Country)
                                    </th>
                                    <th>
                                        @Html.DisplayNameFor(model => model.State)
                                    </th>
                                    <th>
                                        @Html.DisplayNameFor(model => model.City)
                                    </th>
                                    <th>
                                        @Html.DisplayNameFor(model => model.ZipCode)
                                    </th>
                                    <th>
                                        @Html.DisplayNameFor(model => model.CreatedOn)
                                    </th>
                                    <th>
                                        @Html.DisplayNameFor(model => model.IsDefaultLocation)
                                    </th>
                                    <th></th>
                                </tr>
                            </thead>
                            <tbody>
                                @foreach (var item in Model)
                                {
                                    <tr>
                                        <td>
                                            @Html.DisplayFor(modelItem => item.CompanyName)
                                        </td>
                                        <td>
                                            @Html.DisplayFor(modelItem => item.LocationName)
                                        </td>
                                        <td>
                                            @Html.DisplayFor(modelItem => item.Country)
                                        </td>
                                        <td>
                                            @Html.DisplayFor(modelItem => item.State)
                                        </td>
                                        <td>
                                            @Html.DisplayFor(modelItem => item.City)
                                        </td>
                                        <td>
                                            @Html.DisplayFor(modelItem => item.ZipCode)
                                        </td>
                                        <td>
                                            @Html.DisplayFor(modelItem => item.CreatedOn)
                                        </td>
                                        <td>
                                            @*@Html.DisplayFor(modelItem => item.IsDefaultLocation)*@
                                            <input type="checkbox" class="chk" data-id="@item.LocationId" asp-for="@item.IsDefaultLocation" />
                                        </td>
                                        <td>
                                            <a asp-action="Edit" asp-route-id="@item.LocationId" class="fa fa-edit margin-left-10" title="Edit Location"></a>
                                            @if (item.IsDefaultLocation == true)
                                            {

                                            }
                                            else
                                            { 
                                        <a asp-action="Delete" asp-route-id="@item.LocationId" onclick="return confirm('Are sure wants to delete?');" class="fa fa-trash" title="Delete Location"></a>
                                            }
                                            
                                            @*@Html.ActionLink("Edit", "Edit", new { /* id=item.PrimaryKey */ }) |
        @Html.ActionLink("Details", "Details", new { /* id=item.PrimaryKey */ }) |
        @Html.ActionLink("Delete", "Delete", new { /* id=item.PrimaryKey */ })*@
                                        </td>
                                    </tr>
                                }
                            </tbody>
                        </table>
                    </div>
                </div>
                <div>
                </div>
            </div>
        </div>
    </section>
</div>
<script>
    $(document).ready(function () {
        $('.chk').change(function () {
            var id = $(this).attr("data-id");
            var checkbox = $(this);
            alertify.confirm("Are you sure you want to set this default location?", function (e) {
                if (e) {
                    $.get("/Location/SetDefaultLocation", { Id: id }, function (data) {
                        if (data == "Ok") {
                            $('.chk').attr('checked', false);
                            $(checkbox).attr('checked', true);
                            $(checkbox).prop('checked', true);
                            $(checkbox).attr('checked', 'checked');
                            location.reload();
                        }
                        else {
                            $(checkbox).attr('checked', false);
                        }
                    });
                }
                else {
                    alert('0')
                    $(checkbox).attr('checked', false);
                }
            }, function () { $(checkbox).attr('checked', false); }).setHeader('');

        });

    })
    function alertFun() {
        alertify.confirm("Are you sure you want to delete this location?", function (e) {
            if (e) {
                return true;
            }
        }).setHeader('');
    };
</script>